using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using IWshRuntimeLibrary;

using System.Drawing.Imaging;
using System.IO;


namespace thumber
{
    public partial class Form1 : Form
    {
        private string[] m_args;  //=new string[2];
        private Bitmap m_first;
        private string m_dir;
        private int m_w, m_h;

        public Form1()
        {
            InitializeComponent();
            m_args = Environment.GetCommandLineArgs();
            if (m_args.Length == 1)
            {
                string SendToDir = Environment.GetFolderPath(
                    Environment.SpecialFolder.SendTo);
                string ProgramPath = Environment.CurrentDirectory;

                WshShellClass WshS = new WshShellClass();
                IWshShortcut Shortcut = (IWshShortcut)WshS.CreateShortcut(SendToDir + @"\Thumber.lnk");
                Shortcut.TargetPath = ProgramPath + @"\thumber.exe";
                Shortcut.WindowStyle = 1;
                Shortcut.Save();
            }

            if (m_args.Length > 1)
            {
                m_first = getImage(m_args[1]);
                m_dir = Path.GetDirectoryName(m_args[1]);
                trackBar1.Value = 256;
                trackBar1_Scroll(trackBar1, new EventArgs());
            }

        }



        public Bitmap getImage(string name)
        {
            return new Bitmap(name); ;
        }

        public Bitmap thumb(Bitmap image, int m, int n)
        {

            //  Bitmap temp = (Bitmap)image.GetThumbnailImage(m, n, null, IntPtr.Zero);
            Bitmap temp = new Bitmap(m, n, image.PixelFormat);
            temp.SetResolution(image.HorizontalResolution, image.VerticalResolution);
            Graphics g = Graphics.FromImage(temp);

            g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
            g.DrawImage(image,
                new Rectangle(0, 0, m, n),
                new Rectangle(0, 0, image.Width, image.Height),
                GraphicsUnit.Pixel);
            g.Dispose();
            return temp;
        }



        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            m_h = trackBar1.Value;
            m_w = m_h * m_first.Width / m_first.Height;

            label9.Text = m_w.ToString() + " X " + m_h.ToString();

            pictureBox1.Image = thumb(m_first, m_w, m_h);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string thumbdir = m_dir + @"\Thumbs\";
            Directory.CreateDirectory(thumbdir);

            ImageCodecInfo jpegCodec = GetEncoderInfo(ImageFormat.Jpeg);
            EncoderParameters eps = new EncoderParameters(1);
            eps.Param[0] = new EncoderParameter(System.Drawing.Imaging.Encoder.Quality, 50L);

            Bitmap temp;
            Bitmap thumbnail;
            for (int i = 1; i < m_args.Length; i++)
            {
                temp = getImage(m_args[i]);
                thumbnail = thumb(temp, m_w, m_h);
                //thumbnail = thumb(temp, m_w, m_h);
                thumbnail.Save(thumbdir + Path.GetFileName(m_args[i]), jpegCodec, eps);
            }
            Application.Exit();
        }

        public static ImageCodecInfo GetEncoderInfo(ImageFormat type)
        {
            ImageCodecInfo[] encoders;
            encoders = ImageCodecInfo.GetImageEncoders();
            foreach (ImageCodecInfo encoder in encoders)
            {
                if (encoder.FormatID.Equals(type.Guid))
                    return encoder;
            }
            return null;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}